<?php
/*
	SMG WebGUI

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.
	
	Licence information can be found within the file LICENCE.php
	
	The Original Code is SMG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/

class create_ss7_ccspans
{
	
	private $error= "";				//Contains validation errors
	public $error_counter="";		//Contains the number of errors in the form
	public $edit="";				//Contains database returned values for editing
	public $profile_name = array();	//Contains the profile names within the database
	public $profile_counter = "";	//Contains the number of profiles in the database
	private $pick="";				//Contains the data for what was returned to the form
	public $channels="";			//Contains the value of the Channel Map
	public $cic;					//Contains the value of cic
	public $isup="";				//Contains the value of the ISUP Interface
	private $db_location="";		//Contains the database location
	private $table_name="";			//Contains the database table name
	public $profile="";				//Contains the profile name
	public $data="";				//Contains the database class
	private $VL = "";				//Contains value whether link is a voice link or not
	private $media = "";			//Contains the media type
	public $min_digits = "";		//Contains the value of min_digits
	public $clg_nadi = "";			//Contains the value of clg_nadi
	public $cld_nadi = "";			//Contains the value of cld_nadi
	public $obci_bita = "";			//Contains the value of obci_bita
	public $typeCntrl = "";			//Contains the value of typeCntrl
	public $group_num = "";			//Contains the SS7 Span Group Number
	
	//Display function
	function display()
	{
		$this->db_location = "sqlite:../sqlite/cardinfo.db";

		if ($_SESSION['id_num'] == "") 
		{ 
			echo "<h3>SS7 Channel Configuration</h3>";		
		} 
		
		if ($_SESSION['profile_num_ccspan'] == "")
		{
			$a = 1;
			$_SESSION['profile_num_ccspan'] = $a;
		}
		elseif ($_SESSION['profile_num_ccspan'] != "")
		{
			$a = $_SESSION['profile_num_ccspan'];
			$a++;
			$_SESSION['profile_num_ccspan'] = $a;
		}

		$this->check_submit();
		
		$this->table_name = "ss7_isup_profile";
		$this->get_profiles();

		//Figures out the group number
		if ($this->group_num == "")
		{	
			$this->group_num = 1 + $_SESSION['group'];
			$_SESSION['group'] = $this->group_num;
		}
		$_SESSION['group'] = $this->group_num;
		
		?>
	
	<form name="create_profile" method="post">
		<p>
        	The final step in the SS7 configuration is the Channel Mapping.<br />
            You must enter the appopriate channel mapping as well as the CiC value for that span. You must also select the ISUP Interface that this span will be using.<br />
        </p>
		<hr />
        
        <h4>Standard Options</h4>    		   
		<table>
			<tr>
				<td>Profile Name</td>
                <td></td>
				<td align="right"><input type="text" name="profile_name" value="<?php if ($this->profile != "") { echo $this->profile; } else { echo "SS7_CC$a"; }?>" style="text-align:right; width:150px" /></td>
				<td><?php echo $this->error['profile_name']; ?></td>
			</tr>   
            <tr>
            	<td>ISUP Interface</td>
                <td></td>
                <td align="right">
					<select name="isup">
				<?php
				for ($a = 0; $a < $this->profile_counter; $a++)
				{ 
						$hash = "route-" . $this->profile_name[$a]['profile_name'];
						echo "<option value=\"" . $this->profile_name[$a]['profile_name'] . "\""; if ($this->pick[$hash] == "yes") { ?> selected="selected" <?php } echo " style=\"text-align:right\" >" . $this->profile_name[$a]['profile_name'] . "</option>\n";
				}
				?>
				   </select>
                </td>
            </tr>                       
            <tr>
            	<td>CiC Base</td>
                <td></td>
            	<td align="right"><input type="text" name="cic" value="<?php echo $this->cic; ?>" style="text-align:right; width:40px" /></td>
                <td><?php echo $this->error['cic']; ?></td>
            </tr>  
		<?php
		if ($this->VL == "yes" && $this->channels == "")
		{
			if ($this->media == "T1")
			{
				$this->channels = "1-24";
			}
			elseif ($this->media == "E1")
			{
				$this->channels = "1-31";
			}
		}
		?>
        	<tr>
            	<td>Type Control</td>
                <td></td>
                <td align="right">
                	<select name="typeCntrl" style="text-align:right">
                        <option value="controlled" <?php if ($this->pick['typeCntrl_controlled'] == "yes") { ?> selected="selected" <?php } ?> style="text-align:right">Controlled</option>
                        <option value="controlling" <?php if ($this->pick['typeCntrl_controlling'] == "yes") { ?> selected="selected" <?php } ?> style="text-align:right">Controlling</option>
                        <option value="bothway" <?php if ($this->pick['typeCntrl_bothway'] == "yes") { ?> selected="selected" <?php } ?> style="text-align:right">Bothway</option>
                        <option value="incoming" <?php if ($this->pick['typeCntrl_incoming'] == "yes") { ?> selected="selected" <?php } ?> style="text-align:right">Incoming</option>
                        <option value="outgoing" <?php if ($this->pick['typeCntrl_outgoing'] == "yes") { ?> selected="selected" <?php } ?> style="text-align:right">Outgoing</option>                  
                    </select>
                </td>
            </tr>
            <tr>
            	<td>Channel Map</td>
                <td></td>                
            	<td align="right"><input type="text" name="channels" value="<?php echo $this->channels; ?>" style="text-align:right; width:140px" /></td>
                <td><?php echo $this->error['channels']; ?></td>
            </tr>
            <tr>
            	<td>Span Group Number</td>
                <td></td>
            	<td align="right"><input type="text" name="group_num" value="<?php echo $this->group_num; ?>" style="text-align:right; width:40px" /></td>
                <td><?php echo $this->error['group_num']; ?></td>
            </tr>
       </table>
       <br />
       <hr />
       <h4>Advanced Options</h4>
       <font color="red">NOTE: The following parameters are optional. You are not required to fill in any of the options below.</font><br /><br />
       <table>
            <tr>
            	<td>Minimum Incoming Digits<br /> for Overlap Dialing</td>
                <td></td>
            	<td align="right"><input type="text" name="min_digits" value="<?php echo $this->min_digits; ?>" style="text-align:right; width:40px" /></td>
                <td><?php echo $this->error['min_digits']; ?></td>
            </tr>
            <tr>
            	<td>Calling NADI Value</td>
                <td><a href="http://wiki.sangoma.com/ftmod-sangoma-ss7-nadi" target="_blank"><font color="blue"><b>?</b></font></a></td>
            	<td align="right"><input type="text" name="clg_nadi" value="<?php echo $this->clg_nadi; ?>" style="text-align:right; width:40px" /></td>
                <td><?php echo $this->error['clg_nadi']; ?></td>
            </tr>
            <tr>
            	<td>Called NADI Value</td>
                <td><a href="http://wiki.sangoma.com/ftmod-sangoma-ss7-nadi" target="_blank"><font color="blue"><b>?</b></font></a></td>
            	<td align="right"><input type="text" name="cld_nadi" value="<?php echo $this->cld_nadi; ?>" style="text-align:right; width:40px" /></td>
                <td><?php echo $this->error['cld_nadi']; ?></td>
            </tr>
            <tr>
            	<td>Optional Backwards Indicators <br />- In-Band Information</td>
                <td><a href="http://wiki.sangoma.com/ftmod-sangoma-ss7-acm-obci-bita" target="_blank"><font color="blue"><b>?</b></font></a></td>
            	<td align="right">
                	<select name="obci_bita" style="text-align:right">
                        <option value="" style="text-align:right">Not Specified</option>
                        <option value="0" <?php if ($this->pick['obci_bita_0'] == "yes") { ?> selected="selected" <?php } ?> style="text-align:right">0</option>
                        <option value="1" <?php if ($this->pick['obci_bita_1'] == "yes") { ?> selected="selected" <?php } ?> style="text-align:right">1</option>                  
                    </select>
                </td>
                <?php /*<input type="text" name="obci_bita" value="<?php echo $this->obci_bita; ?>" style="text-align:right; width:40px" /></td>*/ ?>
                <td><?php echo $this->error['obci_bita']; ?></td>
            </tr>                                             
       </table>
		<br />
        <hr />
		<input type="submit" name="create" value="<?php if ($_SESSION['id_num'] == "") { echo "Create Channel Map"; } ?>" style="background-color: #CCC"/>
		<input type="submit" name="cancel" value="<?php if ($_SESSION['id_num'] == "") { echo "Cancel"; } ?>" style="background-color: #CCC"/>
	</form>         
	<?php
	}	
	
	//Validates the Form
	function validation()
	{
		
		//Grab the profile name and make sure there isn't a profile already in the database
		//Only to occur if you are making a new profile
		if ($_SESSION['id_num'] == 0)
		{	
			$this->table_name = "ss7_route_profile";
			$this->get_profiles();
			
			for ($z = 0; $z <= $this->profile_counter; $z++)
			{
				if (strtoupper($this->profile_name[$z]['profile_name']) == strtoupper($_REQUEST['profile_name']))
				{
					$this->error['profile_name'] = "<font color=\"red\">Profile already <strong>EXISTS</strong>. Please use a different profile name</font>";
					$this->error_counter++;
				}
			}			
			$this->table_name = "ss7_linkset_profile";
			$this->get_profiles();
			
			for ($z = 0; $z <= $this->profile_counter; $z++)
			{
				if (strtoupper($this->profile_name[$z]['profile_name']) == strtoupper($_REQUEST['profile_name']))
				{
					$this->error['profile_name'] = "<font color=\"red\">Profile already <strong>EXISTS</strong>. Please use a different profile name</font>";
					$this->error_counter++;
				}
			}	
			$this->table_name = "ss7_isup_profile";
			$this->get_profiles();
			
			for ($z = 0; $z <= $this->profile_counter; $z++)
			{
				if (strtoupper($this->profile_name[$z]['profile_name']) == strtoupper($_REQUEST['profile_name']))
				{
					$this->error['profile_name'] = "<font color=\"red\">Profile already <strong>EXISTS</strong>. Please use a different profile name</font>";
					$this->error_counter++;
				}
			}							
		}
		
		//Makes sure the user enters a profile name
		if ($_REQUEST['profile_name'] == "")
		{
			$this->error['profile_name'] = "<font color=\"red\">Please Enter a Profile Name</font>";
			$this->error_counter++;
		}		
	
		if ($_REQUEST['channels'] == "")
		{
			$this->error['channels'] = "<font color=\"red\">Please Enter a <b>Channel Map</b></font>";
			$this->error_counter++;
		}
		
		if ($_REQUEST['group_num'] == "")
		{
			$this->error['group_num'] = "<font color=\"red\">Please Enter a <b>Group Number</b></font>";
			$this->error_counter++;
		}
		elseif (!is_numeric($_REQUEST['group_num']))
		{
			$this->error['group_num'] = "<font color=\"red\">Please Enter a <b>NUMERIC</b> value for the <b>Group Number</b></font>";
			$this->error_counter++;
		}
				
				
		if ($_REQUEST['cic'] == "")
		{
			$this->error['cic'] = "<font color=\"red\">Please Enter a <b>CiC Base</b></font>";
			$this->error_counter++;
		}
		elseif (!is_numeric($_REQUEST['cic']))
		{
			$this->error['cic'] = "<font color=\"red\">Please Enter a <b>NUMERIC</b> value for the <b>CiC Base</b></font>";
			$this->error_counter++;
		}
		
		if (!is_numeric($_REQUEST['min_digits']) && $_REQUEST['min_digits'] != "")
		{
			$this->error['min_digits'] = "<font color=\"red\">Please Enter a <b>NUMERIC</b> value for the <b>Minimum Digits</b></font>";
			$this->error_counter++;
		}
		
		if (!is_numeric($_REQUEST['clg_nadi']) && $_REQUEST['clg_nadi'] != "")
		{
			$this->error['clg_nadi'] = "<font color=\"red\">Please Enter a <b>NUMERIC</b> value for the <b>clg_nadi</b></font>";
			$this->error_counter++;
		}
		elseif ($_REQUEST['clg_nadi'] < 0 || $_REQUEST['clg_nadi'] > 255)
		{
			$this->error['clg_nadi'] = "<font color=\"red\"><b>clg_nadi MUST </b>be between 0 and 255</font>";
			$this->error_counter++;			
		}
		
		if (!is_numeric($_REQUEST['cld_nadi']) && $_REQUEST['cld_nadi'] != "")
		{
			$this->error['cld_nadi'] = "<font color=\"red\">Please Enter a <b>NUMERIC</b> value for the <b>cld_nadi</b></font>";
			$this->error_counter++;
		}
		elseif ($_REQUEST['cld_nadi'] < 0 || $_REQUEST['cld_nadi'] > 255)
		{
			$this->error['cld_nadi'] = "<font color=\"red\"><b>cld_nadi MUST </b>be between 0 and 255</font>";
			$this->error_counter++;			
		}				
		
		/*if (!is_numeric($_REQUEST['obci_bita']) && $_REQUEST['obci_bita'] != "")
		{
			$this->error['obci_bita'] = "<font color=\"red\">Please Enter a <b>NUMERIC</b> value for the <b>obci_bita</b></font>";
			$this->error_counter++;
		}*/
	}	
	
	
	//Retrieves all the SS7 route/linkset Profile Names
	function get_profiles()
	{
		$a = 0;
		$this->db_location = "sqlite:../sqlite/cardinfo.db";
		
		$select = "SELECT profile_name FROM " . $this->table_name . ";";

		try
		{
			//open the database
			$db = new PDO($this->db_location);

			$result = $db->query($select);
		
		    foreach($result as $row)
		    {
				$this->profile_name[$a] = $row;
				$a++;
			}
			// close the database connection
			$db = NULL;
			}
		catch(PDOException $e)
		{
			print 'Exception : '.$e->getMessage();
		}

		$this->profile_counter = $a;
	}	

	function get_link_info()
	{
		$db_location = "sqlite:../sqlite/cardinfo.db";
		$table_name = $_SESSION['card_clicked'] . "_" .  $_SESSION['card_num'] . "_SS7_link";
		
		$param = "voice, line_type";
		$where_param = "port_id = " . $_SESSION['port_num_clicked'];
		
		//Grab the information for that port
		$value = $this->data->select_statement ($db_location, $table_name, $param, $where_param);
		
		if ($value['voice'] != "")
		{
			$this->VL = "yes";
		}
		$this->media = $value['line_type'];
	}

	//Function to return the proper values when entering the page
	function check_submit()
	{

		$this->table_name = "ss7_isup_profile";
		$this->get_profiles();

		for ($a = 0; $a < $this->profile_counter; $a++)
		{
			$hash = "route-" . $this->profile_name[$a]['profile_name'];
			//echo $_REQUEST['route'] . " AND " . $this->profile_name[$a]['profile_name'] . "<br />";
			//echo "hash = $hash<br />";
			
			if ($_REQUEST['isup'] == $this->profile_name[$a]['profile_name'])
			{
				$this->pick[$hash] = "yes";
			}
			elseif ($this->edit['isup'] == $this->profile_name[$a]['profile_name'])
			{
				$this->pick[$hash] = "yes";
			}
			
			//echo "pick = " . $this->pick[$hash]  ."<br />";
		}
		
		if ($_REQUEST['typeCntrl'] == "controlled")
		{
			$this->pick['typeCntrl_controlled'] = "yes";
		}
		elseif ($_REQUEST['typeCntrl'] == "controlling")
		{
			$this->pick['typeCntrl_controlling'] = "yes";
		}
		elseif ($_REQUEST['typeCntrl'] == "bothway")
		{
			$this->pick['typeCntrl_bothway'] = "yes";
		}
		elseif ($_REQUEST['typeCntrl'] == "incoming")
		{
			$this->pick['typeCntrl_incoming'] = "yes";
		}
		elseif ($_REQUEST['typeCntrl'] == "outgoing")
		{
			$this->pick['typeCntrl_outgoing'] = "yes";
		}
		elseif ($this->edit['typeCntrl'] == "controlled")
		{
			$this->pick['typeCntrl_controlled'] = "yes";
		}
		elseif ($this->edit['typeCntrl'] == "controlling")
		{
			$this->pick['typeCntrl_controlling'] = "yes";
		}
		elseif ($this->edit['typeCntrl'] == "bothway")
		{
			$this->pick['typeCntrl_bothway'] = "yes";
		}
		elseif ($this->edit['typeCntrl'] == "incoming")
		{
			$this->pick['typeCntrl_incoming'] = "yes";
		}
		elseif ($this->edit['typeCntrl'] == "outgoing")
		{
			$this->pick['typeCntrl_outgoing'] = "yes";
		}	
		
		if ($_REQUEST['obci_bita'] == "0")
		{
			$this->pick['obci_bita_0'] = "yes";
		}
		elseif ($_REQUEST['obci_bita'] == "1")
		{
			$this->pick['obci_bita_1'] = "yes";
		}	
		elseif ($this->edit['obci_bita'] == "0")
		{
			$this->pick['obci_bita_0'] = "yes";
		}
		elseif ($this->edit['obci_bita'] == "1")
		{
			$this->pick['obci_bita_1'] = "yes";
		}	
	}
}