<?php
/*
	SMG WebGUI

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.
	
	Licence information can be found within the file LICENCE.php
	
	The Original Code is SMG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/

class ss7_linkset_view_profile_class extends database_class
{
	
	//Variable declarations
	private $counter = int;					//Contains the total number of profiles
	private $profile_array = array();		//Contains the Analog Profiles in an array	
	public $total_ports = int;				//Contains the total number of ports for the card in question
	public $conn_type = "";					//Contains the connection type for the port
	private $table_name = "";				//Contains the sql table name
	private $all_cards = array();			//Contains all the cards in the database
	public $error_linkset="";				//Contains the state of linkset binding
	private $bind_error_msg="";				//Contains the error message shown for a bad bind
	private $link="";						//Contains the link in use
	public $clicked_id = "";				//Contains the clicked id for linkset binding
	private $linkset="";					//Contains the Linkset value for the link chosen
	
	//Function that retrieves the linkset profiles from the database and stores it in a multi-dimensional array
	function get_profiles()
	{
		$db_location = "sqlite:../sqlite/cardinfo.db";
		$where_param = "";
		$a = 0;

		$select = "SELECT * FROM " . $this->table_name . ";";
		
		try
		{
			//open the database
			$db = new PDO($db_location);

			$result = $db->query($select);
		
		    foreach($result as $row)
		    {
				$this->profile_array[$a] = $row;
				//echo "card = " . $this->profile_array[$a]['dev_name'] . "<br />";
				$a++;
			}
			// close the database connection
			$db = NULL;
			}
		catch(PDOException $e)
		{
			print 'Exception : '.$e->getMessage();
		}

		$this->counter = $a;
	}

	function display_profiles()
	{
		$table_name = $_SESSION['card_clicked'] . "_" .  $_SESSION['card_num'] . "_SS7_link";
		$where = "port_id = " . $_SESSION['port_num_clicked'];
		$db_location = "sqlite:../sqlite/cardinfo.db";
		$this->link = parent::select_statement($db_location, $table_name, "link_name, linkset", $where);
		
		$where = "id = " . $_SESSION['last_route'];
		$db_location = "sqlite:../sqlite/cardinfo.db";
		$route = parent::select_statement($db_location, "ss7_route_profile", "profile_name", $where);		
		
		if ($_SESSION['linkset'] == "Start")
		{
?>	
		<h2>SS7 LINKSET CONFIGURATION</h2>
<?php			
			if ($this->link['linkset'] != "")
			{
				echo "The list below contains all the SS7 Linksets that have been created on this system.<br />
				You can manage these linksets using the Edit and Delete buttons next to each linkset name.<br /><br />
				The SS7 Signalling Link, <font color=\"red\">" . $this->link['link_name'] . "</font>, is currently bound to the linkset <font color=\"red\">" . $this->link['linkset'] . "</font>.<br />
				In regards to <font color=\"red\">" . $this->link['link_name'] . "</font>, you can create a <b>NEW</b> linkset and then bind it to the new Linkset <b>OR</b> click <b>NEXT</b> to continue.<br />
				When you click next, the linkset it is currently bound to will remain unchanged.";
			}
			else
			{
				echo "The list below contains on the SS7 Linksets created on this system.<br />
				You can manage these linksets using the Edit and Delete buttons next to each linkset name.<br /><br />
				In order to proceed, please <b>BIND <font color=\"red\">" . $this->link['link_name'] . "</font></b> to a Linkset";
			}
		}
		elseif ($_SESSION['linkset'] == "Done")
		{
?>	
		<h2>SS7 ROUTE MANAGEMENT</h2>
<?php			
			echo "The list below contains all the SS7 Routes that have been created on this system.<br />
			You can manage these routes using the Edit and Delete buttons next to each route name.<br /><br />
			You must have a <b>MINIMUM</b> of 1 Route configured on your system. Each Route <b>MUST</b> contain at least 1 Linkset.<br />
		    In order to complete the route configuration, edit or create a route to include any new or existing linksets. Once completed, click on <b>Continue to ISUP Interfaces</b>";
		}
		elseif ($_SESSION['route'] == "Done")
		{
?>	
		<h2>SS7 ISUP INTERFACE MANAGEMENT</h2>
<?php			
			
			echo "The list below contains all the SS7 ISUP Interfaces that have been created on this system.<br />
			You can manage these ISUP Interfaces using the Edit and Delete buttons next to each ISUP Interface name.<br /><br />
			You must have a <b>MINIMUM</b> of 1 ISUP Interface configured on your system.<br />
			In order to complete the ISUP Interface configuration, edit or create a new ISUP Interface. Once completed, click on <b>FINISH</b>. This will return you to the TDM Configuration Setup.";
		}
?>        
        <br />
        <br />
		<form name="view" method="post">
<?php
		if ($_SESSION['linkset'] == "Start")
		{
			
			if ($this->bind_error_msg != "")
			{
				echo $this->bind_error_msg . "<br />";
			}
			
			//Retrieve linkset Profile Information
			$this->table_name = "ss7_linkset_profile";
			$this->get_profiles();

?>	
    	<table>
    		<th>Profile Name</th>
            <th>Adjacent Point Code</th>
    	    <th>Minimum Signalling Links</th>
<?php
            for ($b = 0; $b < $this->counter; $b++)
            {
                echo "\t\t\t<tr>\n";
                if ($_SESSION['last_profile'] == $this->profile_array[$b]['profile_name'])
                {
                    echo "\t\t\t\t<td align=\"center\"><b>" . $this->profile_array[$b]['profile_name'] . "</b></td>\n";
                }
                else
                {
                    echo "\t\t\t\t<td align=\"center\">" . $this->profile_array[$b]['profile_name'] . "</td>\n";
                }
                echo "\t\t\t\t<td align=\"center\">" . $this->profile_array[$b]['apc'] . "</td>\n";
                echo "\t\t\t\t<td align=\"center\">" . $this->profile_array[$b]['minactive'] . "</td>\n";
				if ($this->profile_array[$b]['profile_name'] != $this->link['linkset'])
				{		
	                echo "\t\t\t\t<td align=\"center\"><input type=\"submit\" name=\"use-linkset" . $this->profile_array[$b]['id'] . "\" value=\"Bind Linkset\" style=\"background-color: #CCC\"/></td>\n";			
				}
				else
				{
					echo "\t\t\t\t<td align=\"center\"></td>\n";			
				}
                echo "\t\t\t\t<td align=\"center\"><input type=\"submit\" name=\"config-linkset" . $this->profile_array[$b]['id'] . "\" value=\"Edit Linkset\" style=\"background-color: #CCC\"/></td>\n";
                echo "\t\t\t\t<td align=\"center\"><input type=\"submit\" name=\"delete-linkset" . $this->profile_array[$b]['id'] . "\" value=\"Delete Linkset\" style=\"background-color: #CCC\"/></td>\n";			
                echo "\t\t\t<tr>\n";
                $num_entries++;
				
				if ($this->link['linkset'] != "")
				{
					$_SESSION['next'] = "yes";
				}
            }		
        
            //Puts the number of entries in the database into a session variable
            $_SESSION['num_entries-linkset'] = $num_entries;
?>	        
		</table> 
    	<input type="submit" name="create_linkset" value="Create New Profile" style="background-color: #CCC"/>
        <br />
        <br />
<?php
		}
		elseif ($_SESSION['linkset'] == "Done")
		{
			//Retrieve route Profile Information
			$this->table_name = "ss7_route_profile";
			$this->get_profiles();

?>
       	<table>
    		<th>Profile Name</th>
            <th>Destination Point Code</th>
<?php
			for ($b = 0; $b < $this->counter; $b++)
			{
				echo "\t\t\t<tr>\n";
				if ($_SESSION['last_profile'] == $this->profile_array[$b]['profile_name'])
				{
					echo "\t\t\t\t<td align=\"center\"><b>" . $this->profile_array[$b]['profile_name'] . "</b></td>\n";
				}
				else
				{
					echo "\t\t\t\t<td align=\"center\">" . $this->profile_array[$b]['profile_name'] . "</td>\n";
				}
				echo "\t\t\t\t<td align=\"center\">" . $this->profile_array[$b]['dpc'] . "</td>\n";
				//echo "\t\t\t\t<td align=\"center\"><input type=\"submit\" name=\"use-route" . $this->profile_array[$b]['id'] . "\" value=\"Bind Route\" /></td>\n";
				echo "\t\t\t\t<td align=\"center\"><input type=\"submit\" name=\"config-route" . $this->profile_array[$b]['id'] . "\" value=\"Edit Route\" style=\"background-color: #CCC\"/></td>\n";
				echo "\t\t\t\t<td align=\"center\"><input type=\"submit\" name=\"delete-route" . $this->profile_array[$b]['id'] . "\" value=\"Delete Route\" style=\"background-color: #CCC\"/></td>\n";			
				echo "\t\t\t<tr>\n";
				$num_entries++;
			}		
		
			//Puts the number of entries in the database into a session variable
			$_SESSION['num_entries-route'] = $num_entries;
?>	            
        </table>
    	<input type="submit" name="create_route" value="Create New Profile" style="background-color: #CCC"/>
        <br />
        <br />
<?php
		}
		elseif ($_SESSION['route'] == "Done")
		{	
			unset($_SESSION['linkset']);		
			//Retrieve route Profile Information
			$this->table_name = "ss7_isup_profile";
			$this->get_profiles();

?>        
       	<table>
    		<th>Profile Name</th>
            <th>Self Point Code</th>
<?php
		for ($b = 0; $b < $this->counter; $b++)
		{
			echo "\t\t\t<tr>\n";
			if ($_SESSION['last_profile'] == $this->profile_array[$b]['profile_name'])
			{
				$_SESSION['isup_created'] = "yes";
				echo "\t\t\t\t<td align=\"center\"><b>" . $this->profile_array[$b]['profile_name'] . "</b></td>\n";
			}
			else
			{
				$_SESSION['isup_created'] = "yes";
				echo "\t\t\t\t<td align=\"center\">" . $this->profile_array[$b]['profile_name'] . "</td>\n";
			}
			echo "\t\t\t\t<td align=\"center\">" . $this->profile_array[$b]['spc'] . "</td>\n";
			//echo "\t\t\t\t<td align=\"center\"><input type=\"submit\" name=\"use-isup" . $this->profile_array[$b]['id'] . "\" value=\"Bind ISUP Interface\" /></td>\n";
			echo "\t\t\t\t<td align=\"center\"><input type=\"submit\" name=\"config-isup" . $this->profile_array[$b]['id'] . "\" value=\"Edit ISUP Interface\" style=\"background-color: #CCC\"/></td>\n";
			echo "\t\t\t\t<td align=\"center\"><input type=\"submit\" name=\"delete-isup" . $this->profile_array[$b]['id'] . "\" value=\"Delete ISUP Interface\" style=\"background-color: #CCC\"/></td>\n";			
			echo "\t\t\t<tr>\n";
			$num_entries++;
		}		
	
	//Puts the number of entries in the database into a session variable
	$_SESSION['num_entries-isup'] = $num_entries;
?>	            
        </table>        
    	<input type="submit" name="create_isup" value="Create New Profile" style="background-color: #CCC"/>
        <br />        
		<br />
<?php
		}
		
		if ($_SESSION['error'] != "")
		{
			echo "<br /><br /><b><font color=\"red\">PLEASE CREATE AN ISUP INTERFACE TO PROCEED</font></b><br />\n";
		}	
		if ($_SESSION['linkset'] == "Done")
		{
			echo "<input type=\"submit\" name=\"back-route\" value=\"Back to Linksets\" style=\"background-color: #CCC\"/>";
		}
		elseif ($_SESSION['route'] == "Done")
		{
			echo "<input type=\"submit\" name=\"back-isup\" value=\"Back to Routes\" style=\"background-color: #CCC\"/>";			
		}
?>		
    	<input type="submit" name="back" value="Go Back to Hardware Information" style="background-color: #CCC" />   
<?php
		if ($_SESSION['next'] == "yes")
		{
			echo "<input type=\"submit\" name=\"back-route\" value=\"Next\" style=\"background-color: #CCC\"/>";
		}
		elseif ($_SESSION['linkset'] == "Done")
		{
			echo "<input type=\"submit\" name=\"back-route\" value=\"Continue to ISUP Interfaces\" style=\"background-color: #CCC\"/>";
		}
		elseif ($_SESSION['route'] == "Done" && $_SESSION['isup_created'] == "yes")
		{
			echo "<input type=\"submit\" name=\"back-isup\" value=\"Finish\" style=\"background-color: #CCC\"/>";			
		}
	
?>
</form>        

<?php
	}
	
	//Tokenizes the TON,NPI and MSN values for entry into the form
	function tokenize_values($string)
	{
		$tok = strtok($string, ",");

		$count = 0;
		while ($tok !== false) 
		{
			$token[$count] = $tok;
		    $tok= strtok(",");
			$count++;
		}	
		
		for ($a = 0; $a < $count; $a++)
		{
			if ($token[$a] == " " || $token[$a] == "  ")
			{
			}
			else
			{
				$counter++;
			}
		}
		
		return $counter;		
	}	

	function tokenize_card_name($string)
	{
		$tok = strtok($string, "-");

		$count = 0;
		while ($tok !== false) 
		{
			$token[$count] = $tok;
		    $tok= strtok("-");
			$count++;
		}			
		
		return $token[1];
	}
	
	function check_linksets()
	{
		//Check if the link being bound has the same link type, switchtype and unique SLC value as all the other links attached to this linkset
		//If the linkset is not tied to any link, allow it
		//If it isn't then check to make sure all the attached links have the same values
		
		//Pull the cards
		$db_location = "sqlite:../sqlite/cardinfo.db";
		$this->table_name = "card_present";
		$this->get_profiles();
		$count = 0;
		$error = 0;
		
		for ($b = 0; $b < $this->counter; $b++)
		{
			//Tokenize the name of the card
			$card =$this->tokenize_card_name($this->profile_array[$b]['dev_name']);
			//echo $card . "<br />";
			//check if any cards have a bound linkset
			if ($card == "A101" || $card == "A102" || $card == "A104" || $card == "A108" || $card == "B601")
			{
				$table_name = $card . "_" . $this->profile_array[$b]['id'] . "_SS7_link";
				
				$table_exists = parent::check_for_table ($db_location, $table_name);
				
				if ($table_exists > 1)
				{
					//echo "i am here";
					//Table exists
					$select = "SELECT link_name, SLC, linkset, switchtype, link_type FROM " . $table_name . ";";
					
					try
					{
						//open the database
						$db = new PDO($db_location);
			
						$result = $db->query($select);
					
						foreach($result as $row)
						{
						
							$count++;
							$linkset[$count] = $row;
							//echo "linkset = " . $linkset[$count]['SLC'] . "<br />";
							$b++;
						}
						// close the database connection
						$db = NULL;
						}
					catch(PDOException $e)
					{
						print 'Exception : '.$e->getMessage();
					}
				}
			}

		}	
		//echo $count;
		
		//Compare values
		$table_name = $_SESSION['card_clicked'] . "_" .  $_SESSION['card_num'] . "_SS7_link";
		$where = "port_id = " . $_SESSION['port_num_clicked'];
		$db_location = "sqlite:../sqlite/cardinfo.db";
		$this->link = parent::select_statement($db_location, $table_name, "link_name, SLC, linkset, switchtype, link_type", $where);
		
		$param = "profile_name";
		$where_param = "id = " . $this->clicked_id;
		$values = parent::select_statement ($db_location, "ss7_linkset_profile", $param, $where_param);

		//echo "profile = " . $values['profile_name'] . "<br />";
		//echo "SLC = " . $this->link['SLC'] . "switchtype = " . $this->link['switchtype'] . " linktype = " . $this->link['link_type'] . "<br /><hr />";

		for ($a = 1; $a <= $count; $a++)
		{
			//for ($c = 0; $c <= $b; $c++)
			//{
				//echo "SLC = " . $linkset[$a][$c]['SLC'] . "switchtype = " . $linkset[$a][$c]['switchtype'] . " linktype = " . $linkset[$a][$c]['link_type'] . "<br />";
				//echo "SLC = " . $linkset[$a]['SLC'] . "switchtype = " . $linkset[$a]['switchtype'] . " linktype = " . $linkset[$a]['link_type'] . "<br />";
				if ($this->link['link_name'] != $linkset[$a]['link_name'] && $values['profile_name'] == $linkset[$a]['linkset'])
				{
					//echo "i am here <br />";
					if ($this->link['SLC'] == $linkset[$a]['SLC'] || $this->link['switchtype'] != $linkset[$a]['switchtype'] || $this->link['link_type'] != $linkset[$a]['link_type'])
					{
						$error++;
					}
				}
			//}
		}

		//echo $error . "<br />";

		if ($error > 0 )
		{
			//echo "here";
			$this->error_linkset = "error";
			$this->bind_error_msg = "<font color=\"red\">Cannot <b>BIND</b> Linkset. Please Create a new Linkset for the link <b>" . $this->link['link_name'] . "</b> <br />because the SLC values are the same or they have different a link type or Switchtype as other links bound to <b>" . $values['profile_name'] . "</b></font><br />";
		}
		elseif ($error == 0)
		{
			$this->error_linkset = "pass";
		}
				
	}

}

?>