<?php
/*
	SMG WebGUI

	Software distributed under the License is distributed on an "AS IS" basis,
	WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
	for the specific language governing rights and limitations under the
	License.
	
	Licence information can be found within the file LICENCE.php
	
	The Original Code is SMG WebGUI

	The Initial Developer of the Original Code is
	Shaunt Libarian <shaunt@sangoma.com>

	Contributor(s):
	Shaunt Libarian <shaunt@sangoma.com>
*/

//Starts PHP Sessions
session_start();

//To check if SMG is installed, go to the SMG path and check for ftmod_sangoma_isdn.so
$smg_path = $_SESSION['smg_root_path'] . "/mod/ftmod_sangoma_isdn.so";
$cmd = "ls " . $smg_path;

//Check if Asterisk is installed or Freeswitch is installed
if (shell_exec ("lsmod | grep dahdi > /dev/null 2>  /dev/null") == 0)
{
	$_SESSION['dahdi'] = "True";
}
elseif (shell_exec ($cmd) == 0)
{
	//echo "SMG installed";
	$_SESSION['freetdm'] = "True";
} 

//Forces the use of freeswitch
unset($_SESSION['dahdi']);
//Use ths session variable for Asterisk
//$_SESSION['dahdi'] = "True";

//Turn on both the freetdm and freeswitch sessions for freeswitch use
//$_SESSION['freeswitch'] = "True";

//Turn on the FreeTDM session for Sangoma Media Gateway
$_SESSION['freetdm'] = "True";

//if you are using the freepbx module, bypass the fusionpbx login
if ($_SESSION['dahdi'] == "True")
{
	$_SESSION['username'] = "dahdi";
}

if ($_SESSION['username'] != "")
{
//Includes the File which contains classes
include 'classes.php';
include 'database_classes.php';
include 'display_class.php';	
include 'wanrouter_controls.php';
include 'wanpipe _config/wanpipe.php';
include 'dahdi_config/dahdi_cfg.php';
include 'freetdm_config/freetdm.php';
include 'sqlite/database_creation.php';
include 'smg_ctrl/smg_ctrl.php';

//Class constructors
$data = new database_class;
$tokenization = new wanrouter_hwprobe;
$display = new Display_hwprobe;
$display_common = new Display_common;
$wanrouter = new wanrouter_hwprobe_controls;

//Calls the redirection script to take you to another PHP Page
$wanrouter->redirect($_REQUEST, $data, $tokenization);

//Resets the port and span information
$_SESSION['port'] = 0;
$_SESSION['span_num'] = 0;

//$display_common->html_header();
//$display_common->html_title("Wanrouter Hardware Probe", "../style.css");

//FusionPBX Integration
require_once "../fusionpbx/includes/header.php";

?><h3>TDM Configuration</h3><?php

//Main PHP Script
$parse_results = $tokenization->get_information();
$counter = count($parse_results);
//echo $counter . "<br />";
/*for ($z = 0; $z <= $counter; $z++)
{
	if ($parse_results[$z] == "AFT-B600-SH")
	{
		echo "$z = $parse_results[$z], $parse_results[$int]<br />";
	}	
}*/

if ($counter > 0)
{
	//Initializes the counters
	$a101count = 0;
	$a102count = 0;
	$a104count = 0;		
	$a108count = 0;	
	$b601count = 0;	
	$a200count = 0;
	$a400count = 0;	
	$a500count = 0;	
	$b600count = 0;	
	$b700count = 0;
	
	for ($b = 0; $b <= $counter; $b++)
	{
		//Fills B601 Class with information from wanrouter hwprobe dump		
		if ($parse_results[$b] == "AFT-B601-SH")
		{	
			if ($b601count % 2 == 0)
			{
				$ii++;
				$b601[$ii] = new cardinfo();
			}
			
			$b601[$ii]->class_create_no_shift($parse_results, $b);
			$b601count++;
		}
		
		//Fills B600 Class with information from wanrouter hwprobe dump
		if ($parse_results[$b] == "AFT-B600-SH")
		{
			if ($b600count % 1 == 0)
			{
				$ax++;
				$b600[$ax] = new cardinfo();
			}
			$b600[$ax]->class_create_no_shift($parse_results, $b);
			$b600count++;	
		}
	
		//Fills A200 Class with information from wanrouter hwprobe dump
		if ($parse_results[$b] == "AFT-A200-SH")
		{
			if ($a200count % 1 == 0)
			{
				$g++;
				$a200[$g] = new cardinfo();
			}
			
			$a200[$g]->class_create_shift($parse_results,$b);
			$a200count++;			
		}
		
		//Fills A400 Class with information from wanrouter hwprobe dump
		if ($parse_results[$b] == "AFT-A400-SH")
		{
			if ($a400count % 1 == 0)
			{
				$f++;
				$a400[$f] = new cardinfo();
			}
			
			$a400[$f]->class_create_shift($parse_results,$b);	
			$a400count++;
		}
			
		//Fills A101 Class with information from wanrouter hwprobe dump
		if ($parse_results[$b] == "AFT-A101-SH")
		{
			if ($a101count % 1 == 0)
			{
				$e++;
				$a101[$e] = new cardinfo();
			}
		
			$a101[$e]->class_create_shift($parse_results,$b);
			$a101count++;
		}
			//Fills A102 Class with information from wanrouter hwprobe dump
		if ($parse_results[$b] == "AFT-A102-SH")
		{
			if ($a102count % 2 == 0)
			{
				$d++;
				$a102[$d] = new cardinfo();
			}
			
			$a102[$d]->class_create_shift($parse_results,$b);
			$a102count++;
		}
		
		//Fills A101 Class with information from wanrouter hwprobe dump
		if ($parse_results[$b] == "AFT-A104-SH")
		{
			if ($a104count % 4 == 0)
			{
				$x++;
				$a104[$x] = new cardinfo();			
			}
			
			$a104[$x]->class_create_shift($parse_results,$b);
			$a104count++;
		}
		
		//Fills A108 Class with information from wanrouter hwprobe dump
		if ($parse_results[$b] == "AFT-A108-SH")
		{
			if ($a108count % 8 == 0)
			{
				$y++;
				$a108[$y] = new cardinfo();	
			}
	
			$a108[$y]->class_create_shift($parse_results,$b);
			$a108count++;		
		}
		//Fills A500 Class with information from wanrouter hwprobe dump
		if ($parse_results[$b] == "AFT-A500-SH")
		{
			$q = $b + 1;
			$h = $b + 3;
			$i = $b + 2;
			$s = $b + 4;
			if ($last_bus != $parse_results[$s] || $last_slot != $parse_results[$i])
			{	
				$last_bus = $parse_results[$s];
				$last_slot = $parse_results[$i];			
				$z++;
				$a500[$z] = new cardinfo();		
			}
			$mc = $b + 14;
			$line = $b + 8;
			
			//Takes in all the values for the line type and the fe_line
			if ($parse_results[$mc] == "NT" || $parse_results[$mc] == "TE")
			{
				//echo "$z<br />";
				//echo "$parse_results[$line] = $parse_results[$mc] <br />";
			
				$bri_info[$z][$parse_results[$line]] = $parse_results[$mc];
			}
			//echo "<hr />";
			/*foreach ($bri_info[$z] as $key => $value)
			{
				echo "$bri_info[$z] , $key = $value<br />";
			}*/
			
			$a500[$z]->class_bri($parse_results,$b);
			$a500count++;
		}
			//Fills B700 Class with information from wanrouter hwprobe dump
		if ($parse_results[$b] == "AFT-B700-SH")
		{
			$qli = $b + 1;
			$hil = $b + 3;
			$iil = $b + 2;
			$sil = $b + 4;
					
			if ($last_bus != $parse_results[$sil] || $last_slot != $parse_results[$iil])
			{	
				$last_bus = $parse_results[$sil];
				$last_slot = $parse_results[$iil];			
				$zil++;
				$b700[$zil] = new cardinfo();		
			}
			//echo "last_bus = " . $last_bus . "<br />";
			
			//BRI
			$mc = $b + 14;
			$line = $b + 8;
	
			//Takes in all the values for the line type and the fe_line
			if ($parse_results[$mc] == "NT" || $parse_results[$mc] == "TE" || $parse_results[$mc] == "FXO" || $parse_results[$mc] == "FXS")
			{
				//echo "$parse_results[$line] = $parse_results[$mc] <br />";
			
				$bri_b700_info[$zil][$parse_results[$line]] = $parse_results[$mc];
			}
	
			$b700[$zil]->class_bri($parse_results,$b);
			
			$b700count++;
		}
	}
	
	unset ($_SESSION['last_int']);
	
	//Creates the wanrouterhwprobe table in SQLite
	if ($_SESSION['first_time'] == "")
	{
		$data->create_hardware_table();
	}
	
	$_SESSION['card_count'] = $display->create_html_table($a101, $a102, $a104, $a108, $a200, $a400, $b601, $b700, $a500, $data, $tokenization, $bri_info, $bri_b700_info, $b600);
	$_SESSION['first_time'] = "True";
	unset($_SESSION['group']);
}
else
{
	?>
	<h4>No Cards were detected in the system or the wanpipe drivers are not installed.</h4>
    
    <h5>If you do not have the latest wanpipe driver, please <a href="http://wiki.sangoma.com/wanpipe-linux-drivers" target="_blank">CLICK HERE</a>.</h5>
    <h5>If you have the latest driver, but have not inserted any cards in the system, please power down the machine, insert the appropriate Sangoma Cards, then restart the system and the Webserver.</h5>
    <?php
}
/*
?>
<br />
<a href="index.php">Go Back To Main Page</a>
<?php
*/
//$display_common->html_footer();

//FusionPBX Integration
require_once "../fusionpbx/includes/footer.php";
}
else
{
	header( 'Location:index.php' ) ;
}
?>
